% autocorr.m is a script that calculates
% the 2D autocorrelation function of a
% speckle image.

I = imread('path to image');

%Finding the autocorrelation

% m and n are the numbers of poinst in
% the fast Fourier analysis
m = 2560;
n = 1920;
% Choosing one of the layers in the image
b = double(I(:,:,1))/255;
% Finding the Fourier transform
B = fft2(b,n,m);
% Finding abs^2, i.e. the PSD
PSD = B.*conj(B);
% Inverse Fourier transform
r = ifft2(PSD);
% Sorting the result after using ifft
r = ifftshift(r);
% Finds the maximum value
maks = max(max(r));         
% Normalizing the result
r2 = (r./maks).*2;               

% The values on the axis
xx = 9.6350*(-(m/2):(m/2-1));
yx = 9.6350*(-(n/2):(n/2-1));

% Draws an image of the 2D autocorrelation
figure;
colormap(jet(256));
imagesc(xx,yx,r2);
axis image
title('Autocorrelation, R','FontSize',13);
xlabel('x, [\mum]','FontSize',13)
ylabel('y, [\mum]','FontSize',13)
colorbar;

% Plots the center line along y
figure;
plot(yx,r2(:,(m/2 + 1)),'LineWidth',2);
ylim([0.5 2.1]);
title('Center line (y)','FontSize',13);
xlabel('y, [\mum]','FontSize',13);
ylabel('Autocorrelation, R','FontSize',13);

% Plots the center line along x
figure;
plot(xx,r2((n/2 + 1),:),'LineWidth',2);
ylim([0.5 2.1]);
title('Center line (x)','FontSize',13);
xlabel('x, [\mum]','FontSize',13);
ylabel('Autocorrelation, R','FontSize',13);






