function lagreBilde(I,h)
% lagreBilde Accepts an image and a handle of a 
% figure. It saves the two objects to a 
% userspecified location.

% Asks the user for a location
[FileName,PathName,dill] = uiputfile({'*.bmp','Bitmap (*.bmp)';...
           '*.jpg','JPG (*.jpg)';...
          '*.*','All Files' },'Save Image',...
          'D:\HICFODS\Knut Oyvind\bilder master\newfile.bmp');

% Checks if Cancel is pushed. If not, it saves
% the objects to the location.
if isequal(FileName,0) | isequal(PathName,0)
   disp('User selected Cancel')
else
   FileName2 = strrep(FileName, '.bmp', '');
   % Looks for '.bmp' in the filename, and removes it.
      
   imwrite(I,strcat(PathName,FileName),'bmp');
   % Saves the image as a 'bmp' file.
   
   hgsave(h,strcat(PathName,FileName2));
   % Saves the Matlab handle as a 'fig'.
   
   disp(['User selected',fullfile(PathName,FileName)])
end