function snapshot_picture(thePicture)
% snapshot_picture Acceps an image, calculates
% it's speckle contrast and lets the user save
% the image and a figure containig the image 
% and value of the speckle contrast. The 
% function also asks for a reference image
% in order to remove the background noise.

% Boolean variable, indicates whether there
% is a background noise image or not.
persistent ref
% Variable that contains the background noise
persistent referanse

% Checks if 'referanse' contains any data
if isempty(referanse)
   ref = 0;
end

% Calculates the speckle contrast, compensating
% for background noise if 'ref' = 1. It puts  
% out an error message if the 'ref' = 0, but it
% still calculates the speckle contrast.
if (ref == 1)
     thePicture2 = double(thePicture)/255;
     thePicture2 = thePicture2 - referanse;
     resultat=speckle_contrast(thePicture2);
else
     resultat=speckle_contrast(thePicture);
     errordlg('Name a figure: referanse.', 'No reference image');
     uiwait
end
% Generates a figure
h = figure;
% Draws the image in the figure
image(thePicture);
axis image;
% Inserts the value of the speckle contrast in the figure
title(['Speckle contrast ',num2str(resultat(1))]);
% Demanding a varibel name for the image
pictureName = ...
    inputdlg({'Name of variable (choose OK to save):'},...
                        'Image Name', 1, {'theImage'});
% If the user push the OK button it saves the image,
% and exports it to the image as a varible to 
% the Matlab Workspace.
if(length(pictureName) ~= 0) % check for cancel button
     assignin('base', pictureName{1}, thePicture);
     lagreBilde(thePicture,h);
end
% Checks if the variable name is 'referanse'
if (strcmp(pictureName(1),'referanse'))
     referanse = double(thePicture)/255;
     ref = 1;
end